# $Id: node.mk 11475 2010-06-03 21:02:23Z manuelbi $

include build/node-start.mk

SUBDIRS:= \
	v9990 ld

SRC_HDR:= \
	VDP VDPCmdEngine VDPVRAM SpriteChecker ADVram \
	VideoSourceSetting \
	Renderer RendererFactory RenderSettings PixelRenderer \
	SDLVideoSystem SDLRasterizer FBPostProcessor SDLSnow \
	DummyRenderer \
	BitmapConverter CharacterConverter \
	PNG \
	VideoSystem Display VideoLayer \
	Layer \
	DummyVideoSystem \
	SDLImage BaseImage \
	FrameSource RawFrame PostProcessor \
	DeinterlacedFrame DoubledFrame SuperImposedFrame \
	OutputSurface VisibleSurface SDLVisibleSurface \
	SDLOffScreenSurface \
	Icon \
	AviRecorder AviWriter ZMBVEncoder \
	ScalerFactory \
	Scaler1

ifneq ($(MAX_SCALE_FACTOR), 1)
SRC_HDR += \
	Scanline \
	Scaler2 Scaler3 \
	Simple2xScaler Simple3xScaler \
	SaI2xScaler SaI3xScaler \
	Scale2xScaler Scale3xScaler \
	HQ2xScaler HQ2xLiteScaler \
	HQ3xScaler HQ3xLiteScaler \
	RGBTriplet3xScaler \
	Multiply32
endif

ifeq ($(PLATFORM_GP2X), 1)
SRC_HDR += \
	GP2XMMUHack
endif

HDR_ONLY:= \
	DisplayMode \
	VRAMObserver \
	SpriteConverter \
	PixelOperations \
	LineScalers \
	Scaler \
	Rasterizer \
	HQCommon \
	VideoSystemChangeListener \
	LayerListener \
	VideoSource \
	SDLSurfacePtr

DIST:= \
	HQ2xScaler-1x1to2x2.nn \
	HQ2xScaler-1x1to1x2.nn \
	HQ3xScaler-1x1to3x3.nn \
	HQ2xLiteScaler-1x1to2x2.nn \
	HQ2xLiteScaler-1x1to1x2.nn \
	HQ3xLiteScaler-1x1to3x3.nn \
	FBPostProcessor-x64.asm \
	FBPostProcessor-x86.asm \
	LineScalers-x64.asm \
	LineScalers-x86.asm \
	Scale2xScaler-x64.asm \
	Scale2xScaler-x86.asm \
	Scanline-x64.asm \
	Scanline-x86.asm \
	Simple2xScaler-x64.asm \
	Simple2xScaler-x86.asm \
	Simple3xScaler-x64.asm \
	Simple3xScaler-x86.asm

SRC_HDR_$(COMPONENT_GL)+= \
	SDLGLOutputSurface SDLGLVisibleSurface SDLGLOffScreenSurface \
	GLSnow GLUtil GLImage \
	GLPostProcessor GLScalerFactory GLScaler \
	GLSimpleScaler GLScaleNxScaler GLSaIScaler GLTVScaler \
	GLRGBScaler GLHQScaler GLHQLiteScaler

include build/node-end.mk

